<?php

namespace ModulesGarden\Servers\ProxmoxCloudVps\App\UI\Admin\Product\Sections\Lxc;

use ModulesGarden\ProxmoxAddon\App\Services\Utility;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Interfaces\AdminArea;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Select;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Switcher;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Fields\Text;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Sections\BoxSection;
use ModulesGarden\Servers\ProxmoxCloudVps\Core\UI\Widget\Forms\Sections\HalfPageSection;

class NetworkSection extends BoxSection implements AdminArea
{
    protected $id = 'networkSection';
    protected $name = 'networkSection';
    protected $title = 'networkSection';
    /**
     * @var HalfPageSection
     */
    private $leftSection;
    /**
     * @var HalfPageSection
     */
    private $rightSection;

    public function initContent()
    {
        $this->leftSection  = new HalfPageSection('leftSection');
        $this->rightSection = new HalfPageSection('rightSection');
        $this->addSection($this->leftSection)
            ->addSection($this->rightSection);
        $this->initFields();
    }

    private function initFields()
    {
        //IPv4 Network Mode
        $field = new Select('customconfigoption[ipv4NetworkMode]');
        $field->setDescription('tip');
        $this->leftSection->addField($field);
        //IPv6 Network Mode
        $field = new Select('customconfigoption[ipv6NetworkMode]');
        $field->setDescription('tip');
        $field->setDefaultValue('static');
        $this->rightSection->addField($field);
        //Bridge
        $field = new Select('customconfigoption[bridge]');
        $field->setDescription('tip');
        $this->leftSection->addField($field);
        //Private Bridge
        $field = new Select('customconfigoption[privateBridge]');
        $field->setDescription('tip');
        $this->rightSection->addField($field);
        //Firewall
        $field = new Switcher('customconfigoption[networkFirewall]');
        $field->setDescription('tip');
        $this->leftSection->addField($field);
        //VLAN TAG Range From
        $field = new Text('customconfigoption[tagFrom]');
        $field->setDescription('tip');
        $this->rightSection->addField($field);
        //VLAN TAG Range To
        $field = new Text('customconfigoption[tagTo]');
        $field->setDescription('tip');
        $this->leftSection->addField($field);
        //Tag
        $field = new Select('customconfigoption[tags][]');
        $field->enableMultiple();
        $field->setDescription('tip');
        if(Utility::isIpManagerProxmoxVPSIntegration()){
            $field->setDescription('ip_manager_integration_tag');
        }
        $this->rightSection->addField($field);

    }

}
